module HTTP(copyUrl,fetchUrl,exists) where

#ifdef HAVE_HTTP
import Network.HTTP
import Network.URI
#endif

copyUrl :: String -> String -> a -> IO ()
copyUrl url file _cache = fetchUrl url >>= writeFile file

#ifdef HAVE_HTTP
exists :: Bool
exists = True

fetchUrl :: String -> IO String
fetchUrl url = case parseURI url of
    Nothing -> fail $ "Invalid URI: " ++ url
    Just uri -> do resp <- simpleHTTP $ Request { rqURI = uri,
                                                  rqMethod = GET,
                                                  rqHeaders = [],
                                                  rqBody = "" }
                   case resp of
                     Right res@Response { rspCode = (2,0,0) } -> return (rspBody res)
                     Right Response { rspCode = (x,y,z) } ->
                         fail $ "HTTP " ++ show x ++ show y ++ show z ++ " error getting " ++ show uri
                     Left err -> fail $ show err

#else

exists :: Bool
exists = False

fetchUrl :: String -> IO String
fetchUrl _ = fail "Network.HTTP does not exist"

#endif


